from token import Token
from ast import AST
from generic import GenericASTTraversal


class PyCodeGenerator(GenericASTTraversal):
	def __init__(self, ast):
		GenericASTTraversal.__init__(self, ast)

	def default(self, node):
		dump("%20s"%node.type)
		try:
			dump(" (%s)"%str(node.attr))
		except:
			pass
		dump("\n")

	


if __name__ == '__main__':
	import sys
	def dump(s):
		sys.stdout.write(s)

	from FlScanner import FlScanner
	from FlParser import FlParser
	#filename = sys.argv[1]
	filename = "test.fl"
	f = open(filename)
	input = f.read()
	scanner = FlScanner()
	tokens = scanner.tokenize(input)
	#dump( "Tokens:"+str(tokens)+"\n")


	parser = FlParser()
	parseTree =  parser.parse(tokens)
	#dump( "parseTree: " + str(parseTree)+"\n")


	codeGen = PyCodeGenerator(parseTree)
	dump( "# postorder:"+"\n")

	dump( "#"+"\n")

	codeGen.postorder()
	dump( "\npreorder:"+"\n")
	codeGen.preorder()
	#codeGen.preorder()



